﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MultiColumnHeaders.Controllers;
using Newtonsoft.Json;
using MultiColumnHeaders.Models;

namespace MultiColumnHeaders.Controllers
{
    public class HomeController : Controller
    {
        public static AdventureWorksModelContainer context = new AdventureWorksModelContainer();
        //
        // GET: /Home/

        public ActionResult Index()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Multi-Column Headers feature.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "This demo demonstrates the Ignite UI Grids' Multi-Column Headers feature.";
            return View();
        }

        public ActionResult MVCDemo()
        {
            ViewBag.Message = "Ignite UI Grid's Multi-Column Headers feature using the ASP.NET MVC helpers. Additionally enabled features such as Column Moving and Resizing that relfect interaction to their child columns. Also the group headers don't get Feature Chooser gear icon as Filtering for example doesn't apply to them. Bonus styling.";
            return View(context.People.Take(20));
        }

        public ActionResult Demo()
        {
            ViewBag.Message = "Ignite UI Grid's Multi-Column Headers feature. Additionally enabled features such as Hiding and Resizing that relfect interaction to their child columns. Also the group headers don't get Feature Chooser gear icon as Filtering for example doesn't apply to them. Bonus styling and Modern UI theme.";
            return View(context.People.Take(20));
        }

        public ActionResult HMVCDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's Multi-Column Headers feature using the ASP.NET MVC helpers on both the parent and child layouts. Nested group headers. Bonus styling.";
            /* Lie and cheat to make the Departments with Employees and also allow it be normally seriazable */
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).AsQueryable();
            return View(departments);
        }

        public ActionResult HDemo()
        {
            ViewBag.Message = "Ignite UI Hierarchical Grid's Multi-Column Headers feature on both the parent and child layouts. Nested group headers. Bonus styling.";
            return View();
        }

        public JsonResult Departments()
        {
            var departments = context.Departments.Select(d => new
            {
                DepartmentID = d.DepartmentID,
                Name = d.Name,
                GroupName = d.GroupName,
                ModifiedDate = d.ModifiedDate,
                Employees = d.EmployeeDepartmentHistories.Where(x => x.DepartmentID == d.DepartmentID).Where(x => x.EndDate == null).Select(x => x.Employee).Select(x => new
                {
                    BusinessEntityID = x.BusinessEntityID,
                    DepartmentID = d.DepartmentID,
                    NationalIDNumber = x.NationalIDNumber,
                    LoginID = x.LoginID,
                    OrganizationLevel = x.OrganizationLevel,
                    JobTitle = x.JobTitle,
                    BirthDate = x.BirthDate,
                    MaritalStatus = x.MaritalStatus,
                    Gender = x.Gender,
                    HireDate = x.HireDate,
                    SalariedFlag = x.SalariedFlag,
                    VacationHours = x.VacationHours,
                    SickLeaveHours = x.SickLeaveHours
                })
            }).ToList();
            return Json(departments, JsonRequestBehavior.AllowGet);
        }
    }
}
